Option Explicit

Const debugFlag=0

Dim vDate,vStartDate,vEndDate,Interval
Dim sKoteiData(20,3)
Dim sAtcFileName,sIniName,sIntFile
Dim i,j,k
Dim oFS,oFolder,oRE,oArg,strSataid
Dim sDDE,sGMSLP,oShell,sCommand,lRet,sAppName
Dim intMAX,LoopNum,defaultLoopNum,intAjtHour

set oShell	= CreateObject("WScript.Shell")
set oFS		= CreateObject("Scripting.FileSystemObject")
set oRE		= new RegExp		
set oArg	= WScript.Arguments

'#####################################################################################
'	initial setting
defaultLoopNum = 13
intMAX		= 48
Interval	= 1/6	'intervals of imagery to be displayed
intAjtHour	= 9	'time-difference between UTC and local time

sAtcFileName	= oFS.GetBaseName(WSCript.ScriptName) & ".atc"
sGMSLP			= "GMSLPD\GMSLPD64.EXE"

'	fixed data name
'	0:name of imagery	1:offset(number)	2:file path
'	add "'" at head of lines if not necessary
sKoteiData(0,0)	= "IR[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(1,0)	= "I2[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(2,0)	= "VS[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(3,0)	= "WV[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(4,0)	= "I4[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(5,0)	= "B01_[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(6,0)	= "B02_[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(7,0)	= "B04_[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(8,0)	= "B05_[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(9,0)	= "B06_[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(10,0)	= "B09_[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(11,0)	= "B10_[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(12,0)	= "B11_[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(13,0)	= "B12_[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(14,0)	= "B14_[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(15,0)	= "B16_[YYYY][MM][DD].Z[HH][mm]"
sKoteiData(16,0)	= "GS[YY][MM][DD].Z[HH]"

sKoteiData(0,1)	= 0
sKoteiData(1,1)	= 0
sKoteiData(2,1)	= 0
sKoteiData(3,1)	= 0
sKoteiData(4,1)	= 0
sKoteiData(5,1)	= 0
sKoteiData(6,1)	= 0
sKoteiData(7,1)	= 0
sKoteiData(8,1)	= 0
sKoteiData(9,1)	= 0
sKoteiData(10,1)	= 0
sKoteiData(11,1)	= 0
sKoteiData(12,1)	= 0
sKoteiData(13,1)	= 0
sKoteiData(14,1)	= 0
sKoteiData(15,1)	= 0
sKoteiData(16,1)	= 36

'	folders in which SATAID imagery is saved
sKoteiData(0,2)	= "..\SATAID_Image"
sKoteiData(1,2)	= "..\SATAID_Image"
sKoteiData(2,2)	= "..\SATAID_Image"
sKoteiData(3,2)	= "..\SATAID_Image"
sKoteiData(4,2)	= "..\SATAID_Image"
sKoteiData(5,2)	= "..\SATAID_Image"
sKoteiData(6,2)	= "..\SATAID_Image"
sKoteiData(7,2)	= "..\SATAID_Image"
sKoteiData(8,2)	= "..\SATAID_Image"
sKoteiData(9,2)	= "..\SATAID_Image"
sKoteiData(10,2)	= "..\SATAID_Image"
sKoteiData(11,2)	= "..\SATAID_Image"
sKoteiData(12,2)	= "..\SATAID_Image"
sKoteiData(13,2)	= "..\SATAID_Image"
sKoteiData(14,2)	= "..\SATAID_Image"
sKoteiData(15,2)	= "..\SATAID_Image"
sKoteiData(16,2)	= "..\SATAID_Image"
sKoteiData(17,2)	= "..\SATAID_Obs"

'#####################################################################################

'	read argument
if oArg.Count=0 then
	LoopNum	= InputBox("Input animation time","Invalid input is treated as 13 hours loop",defaultLoopNum)
	if LoopNum="" then WScript.Quit
	if isNumeric(LoopNum)=False then LoopNum=defaultLoopNum
	if CInt(LoopNum)<1 or CInt(LoopNum)>intMAX then LoopNum=13
	
ElseIf oArg.Count=2 then
	LoopNum =CInt(oArg(0))
	if LoopNum<1 or LoopNum>intMAX then LoopNum=13	
	strSataid = oArg(1)
	
End if

for i=0 to 15
	if i>=Len(strSataid) then Exit For
	if Mid(strSataid,i+1,1)=0 then sKoteiData(i,0)=Empty
next

'-------------------------------------------------------------------------------
'		read wis setting
Dim oFSText,strData,sIni

sIni = "sataid.ini"
Set oFSText = oFS.OpenTextFile(sIni)

Do While Not oFSText.AtEndOfStream
	strData = oFSText.ReadLine
	if debugFlag<>0 then WScript.Echo strData

	Select Case strData
		Case "Time":
			strData = oFSText.ReadLine
			intAjtHour = strData
	End Select
Loop

'------------------------------------------------------------------------------------------------
vEndDate	= Date+TimeSerial(Hour(Time)+1-intAjtHour,0,0)
vStartDate	= vEndDate-(LoopNum+1.0)/24.0

sAppName = oFS.GetBASEName(sGMSLP)
If LoopNum=4  then
	sIniName = "-ini=gmslpd03.ini"
	sIntFile = "FILE=GMSLPD\gmslpd03.ini"

ElseIf LoopNum=7  then
	sIniName = "-ini=gmslpd06.ini"
	sIntFile = "FILE=GMSLPD\gmslpd06.ini"
		
ElseIf LoopNum=13 then
	sIniName = "-ini=gmslpd12.ini"
	sIntFile = "FILE=GMSLPD\gmslpd12.ini"

ElseIf LoopNum=25 then
	sIniName = "-ini=gmslpd24.ini"
	sIntFile = "FILE=GMSLPD\gmslpd24.ini"

ElseIf LoopNum=37 then
	sIniName = "-ini=gmslpd36.ini"
	sIntFile = "FILE=GMSLPD\gmslpd36.ini"

Else 
	sIniName = "-ini=gmslpd12.ini"
	sIntFile = "FILE=GMSLPD\gmslpd12.ini"
	
End if

Dim fso,MyDir,curDir

set fso = CreateObject("Scripting.FileSystemObject")
Set MyDir = fso.GetFolder(".")
curDir = MyDir.path

'msgbox curDir

Call MakeAtc(vStartDate,vEndDate,Interval,sAtcFileName,sKoteiData,sIntFile)

sCommand = "cmd /c " & sGMSLP & " " & sIniName & " " & chr(34) & curDir & "\" & sAtcFileName & chr(34)
if debugFlag<>0 then WScript.Echo sCommand
oShell.Run sCommand,0,False

set oShell	= Nothing
set oFS		= Nothing
set oRE		= Nothing

'---------------------------------------------------------------------
'	ATC file making function
Function MakeAtc(vStartDate,vEndDate,Interval,sATCName,sKoteiData,sIntFile)
	
	Dim i,j,k
	Dim vDate
	Dim sHEAD,sINIT,sSubDir,oFolder
	Dim oFS,oFile
	Dim sGMSNames(600),sFile
	Dim sKoteiNames(600)
	Dim sLine
	Dim iLoopNum,sWriteData
	Dim iOffset
	Dim bRepet
	Dim sHiduke(6)
	iOffset	= 200

	set oFS	= CreateObject("Scripting.FileSystemobject")
	
	'	Check subdirectory
	for i=0 to Ubound(sKoteiData,1)
		if oFS.FolderExists(sKoteiData(i,2)) then
			set oFolder = oFS.GetFolder(sKoteiData(i,2))
'msgbox oFolder.Name

			if InStr(sSubDir,UCase(oFolder.Name))=0 then
				sSubDir = sSubDir & UCase(sKoteiData(i,2)) & ";"
			End if
		End if
	next	'i
	set oFolder = Nothing
	
	sHEAD = "[TITLE]" & vbCRLF & "[SUBDIR]" & vbCRLF & sSubDir & vbCRLF & "[NOTE]" & vbCRLF & "atcnote.dat" & vbCRLF & "[IMAGE]" & vbCRLF
	
	'	fixed name loop
	for i=0 to Ubound(sKoteiData,1)
		j=0
		vDate = vStartDate
		Do While vDate<=vEndDate
			vDate = vStartDate + Interval*(j-sKoteiData(i,1))/24.0	'Set time with offset
			if sKoteiData(i,0)<>"" then
				sFile = MakeOKIKAE(sKoteiData(i,0),vDate)
				if oFS.FileExists(sKoteiData(i,2) & "\" & sFile) then
					'	check duplication
					bRepet = TRUE	'TRUE if no duplication
					k=0
					if (j-sKoteiData(i,1)+iOffset)>2.0/Interval then k=(j-sKoteiData(i,1)+iOffset)-2.0/Interval
					Do while k<j-sKoteiData(i,1)+iOffset
						if InStr(sKoteiNames(k),sFile)<>0 then bRepet=False:Exit Do
						k=k+1
					Loop
					if bRepet then
						if debugFlag<>0 then WScript.Echo "Date:	" & vDate & "	j	" & j & "File name	" & sFile
						if (j-sKoteiData(i,1)+iOffset)>=0 then
							sKoteiNames(j-sKoteiData(i,1)+iOffset) = sKoteiNames(j-sKoteiData(i,1)+iOffset) & " "& sFile
						End if
					Else
						if debugFlag<>0 then WScript.Echo Now & vbTab & sFile & "	is duplicated."
					End if
				End if
			End if
			j=j+1
		Loop
	next	'i

	'	Final write
	Call MakeHiduke(sHiduke,vStartDate)
	sINIT = "[INIT]" & vbCRLF & "IMAGE=IR" & vbCRLF & "TERM=" & sHiduke(0) & "." & sHiduke(2) & "." & sHiduke(3) & "." & sHiduke(4) & "." & sHiduke(5) & "Z "
	Call MakeHiduke(sHiduke,vEndDate)
	sINIT = sINIT & sHiduke(0) & "." & sHiduke(2) & "." & sHiduke(3) & "." & sHiduke(4) & "." & sHiduke(5) & "Z" 
	sINIT = sINIT & vbCRLF & "FONT=24" & vbCRLF & "SUMRY=ON" & vbCRLF & sIntFile
	sINIT = sINIT & vbCRLF &"[TEXT]" & vbCRLF& vbCRLF
	sINIT = sINIT & vbCRLF & "<<TEXT_END>>"

	'	Write
	iLoopNum=1
'	for i=0 to CInt((vEndDate-vStartDate)/Interval*24.0)
	for i=0 to UBound(sKoteiNames)
		sLine = sKoteiNames(i) 
		if TRIM(sLine)<>"" then
			if debugFlag<>0 then WScript.echo (vStartDate+Interval*(i-iOffset)/24.0) & "	Display	i	" & i & vbTab & sLine
			sWriteData = sWriteData& MakeTimeHead(vStartDate+Interval*(i-iOffset)/24.0) & sLine & vbCRLF
			iLoopNum=iLoopNum+1
		End if
	next	'i
	
	set oFile =oFS.CreateTextFile(sAtcFileName,TRUE)
	oFile.Write(sHEAD & iLoopNum & vbCRLF & sWriteData & sINIT)
	oFile.Close
	
	if debugFlag<>0 then WScript.Echo sHEAD & iLoopNum & vbCRLF & sWriteData & sINIT

	set oFS	= Nothing
	
End Function

'---------------------------------------------------------------------
'	replacement function
Function MakeOKIKAE(sData,vDate)
	
	Dim sHiduke(10)
	Dim sFileName
	
	Call MakeHiduke(sHiduke,vDate)
	
	sFileName = sData
	
	sFileName = Replace(sFileName,"[YYYY]",sHiduke(0))
	sFileName = Replace(sFileName,"[YY]",sHiduke(1))
	sFileName = Replace(sFileName,"[MM]",sHiduke(2))
	sFileName = Replace(sFileName,"[DD]",sHiduke(3))
	sFileName = Replace(sFileName,"[HH]",sHiduke(4))
	sFileName = Replace(sFileName,"[mm]",sHiduke(5))
	
	MakeOKIKAE = sFileName
	
End Function

'---------------------------------------------------------------------
'	return start time of animation (ATC)
Function MakeTimeHead(vDate)
	
	Dim sHiduke(10)
	Call MakeHiduke(sHiduke,vDate)
	MakeTimeHead = sHiduke(1) & "." & sHiduke(2) & "." & sHiduke(3) & "." & sHiduke(4) & sHiduke(5) & "Z"
	
End Function
'---------------------------------------------------------------------
Function MakeHiduke(sHiduke,vDate)
 
	Dim i
 
	sHiduke(0) = Year(vDate)
	sHiduke(1) = Right(sHiduke(0),2)
	sHiduke(2) = Month(vDate)
	sHiduke(3) = Day(vDate)
	sHiduke(4) = Hour(vDate)
	sHiduke(5) = Minute(vDate)
 
	for i=2 to 5
		if CInt(sHiduke(i))<10 then sHiduke(i) ="0" & sHiduke(i)
	next	'i
 
End Function